/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables;


import com.tabajara.base.Indexes;
import com.tabajara.base.Keys;
import com.tabajara.base.Public;
import com.tabajara.base.tables.records.AtuadorRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Atuador extends TableImpl<AtuadorRecord> {

    private static final long serialVersionUID = 9471218;

    /**
     * The reference instance of <code>public.atuador</code>
     */
    public static final Atuador ATUADOR = new Atuador();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<AtuadorRecord> getRecordType() {
        return AtuadorRecord.class;
    }

    /**
     * The column <code>public.atuador.atuid</code>.
     */
    public final TableField<AtuadorRecord, Integer> ATUID = createField("atuid", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('atuador_atuid_seq'::regclass)", org.jooq.impl.SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>public.atuador.atudescricao</code>.
     */
    public final TableField<AtuadorRecord, String> ATUDESCRICAO = createField("atudescricao", org.jooq.impl.SQLDataType.VARCHAR(50), this, "");

    /**
     * The column <code>public.atuador.atuparametro</code>.
     */
    public final TableField<AtuadorRecord, String> ATUPARAMETRO = createField("atuparametro", org.jooq.impl.SQLDataType.VARCHAR(50), this, "");

    /**
     * The column <code>public.atuador.atuatualizacao</code>.
     */
    public final TableField<AtuadorRecord, Integer> ATUATUALIZACAO = createField("atuatualizacao", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.atuador.atuativo</code>.
     */
    public final TableField<AtuadorRecord, String> ATUATIVO = createField("atuativo", org.jooq.impl.SQLDataType.VARCHAR(20), this, "");

    /**
     * The column <code>public.atuador.atuvirtual</code>.
     */
    public final TableField<AtuadorRecord, String> ATUVIRTUAL = createField("atuvirtual", org.jooq.impl.SQLDataType.VARCHAR(20), this, "");

    /**
     * The column <code>public.atuador.fktipatuid</code>.
     */
    public final TableField<AtuadorRecord, Integer> FKTIPATUID = createField("fktipatuid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * Create a <code>public.atuador</code> table reference
     */
    public Atuador() {
        this(DSL.name("atuador"), null);
    }

    /**
     * Create an aliased <code>public.atuador</code> table reference
     */
    public Atuador(String alias) {
        this(DSL.name(alias), ATUADOR);
    }

    /**
     * Create an aliased <code>public.atuador</code> table reference
     */
    public Atuador(Name alias) {
        this(alias, ATUADOR);
    }

    private Atuador(Name alias, Table<AtuadorRecord> aliased) {
        this(alias, aliased, null);
    }

    private Atuador(Name alias, Table<AtuadorRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, "");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return Public.PUBLIC;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.ATUADOR_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<AtuadorRecord, Integer> getIdentity() {
        return Keys.IDENTITY_ATUADOR;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<AtuadorRecord> getPrimaryKey() {
        return Keys.ATUADOR_PKEY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<AtuadorRecord>> getKeys() {
        return Arrays.<UniqueKey<AtuadorRecord>>asList(Keys.ATUADOR_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<AtuadorRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<AtuadorRecord, ?>>asList(Keys.ATUADOR__ATUADOR_FKTIPATUID_FKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Atuador as(String alias) {
        return new Atuador(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Atuador as(Name alias) {
        return new Atuador(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Atuador rename(String name) {
        return new Atuador(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Atuador rename(Name name) {
        return new Atuador(name, null);
    }
}
